aboutsummaryrefslogtreecommitdiffstats
path: root/tools/testing/selftests/kexec/kexec_common_lib.sh
diff options
context:
space:
mode:
authorMimi Zohar <zohar@linux.ibm.com>2019-01-24 08:57:20 -0500
committerShuah Khan <skhan@linuxfoundation.org>2019-04-17 15:32:02 -0600
commit5025b0f0fa25a0b71ae7ada96b18b6b63c24302f (patch)
treedbce97c120395501cab762e242bbab18f818caa2 /tools/testing/selftests/kexec/kexec_common_lib.sh
parentselftests/kexec: cleanup the kexec selftest (diff)
downloadlinux-dev-5025b0f0fa25a0b71ae7ada96b18b6b63c24302f.tar.xz
linux-dev-5025b0f0fa25a0b71ae7ada96b18b6b63c24302f.zip
selftests/kexec: define a set of common functions
Define, update and move get_secureboot_mode() to a common file for use by other tests. Updated to check both the efivar SecureBoot-$(UUID) and SetupMode-$(UUID), based on Dave Young's review. Signed-off-by: Mimi Zohar <zohar@linux.ibm.com> Reviewed-by: Petr Vorel <pvorel@suse.cz> Signed-off-by: Shuah Khan <skhan@linuxfoundation.org>
Diffstat (limited to 'tools/testing/selftests/kexec/kexec_common_lib.sh')
-rwxr-xr-xtools/testing/selftests/kexec/kexec_common_lib.sh38
1 files changed, 38 insertions, 0 deletions
diff --git a/tools/testing/selftests/kexec/kexec_common_lib.sh b/tools/testing/selftests/kexec/kexec_common_lib.sh
new file mode 100755
index 000000000000..05376be6a6f7
--- /dev/null
+++ b/tools/testing/selftests/kexec/kexec_common_lib.sh
@@ -0,0 +1,38 @@
+#!/bin/sh
+# SPDX-License-Identifier: GPL-2.0
+
+# Check efivar SecureBoot-$(the UUID) and SetupMode-$(the UUID).
+# The secure boot mode can be accessed either as the last integer
+# of "od -An -t u1 /sys/firmware/efi/efivars/SecureBoot-*" or from
+# "od -An -t u1 /sys/firmware/efi/vars/SecureBoot-*/data". The efi
+# SetupMode can be similarly accessed.
+# Return 1 for SecureBoot mode enabled and SetupMode mode disabled.
+get_secureboot_mode()
+{
+ local efivarfs="/sys/firmware/efi/efivars"
+ local secure_boot_file="$efivarfs/../vars/SecureBoot-*/data"
+ local setup_mode_file="$efivarfs/../vars/SetupMode-*/data"
+ local secureboot_mode=0
+ local setup_mode=0
+
+ # Make sure that efivars is mounted in the normal location
+ if ! grep -q "^\S\+ $efivarfs efivarfs" /proc/mounts; then
+ log_skip "efivars is not mounted on $efivarfs"
+ fi
+
+ # Due to globbing, quoting "secure_boot_file" and "setup_mode_file"
+ # is not possible. (Todo: initialize variables using find or ls.)
+ if [ ! -e $secure_boot_file ] || [ ! -e $setup_mode_file ]; then
+ log_skip "unknown secureboot/setup mode"
+ fi
+
+ secureboot_mode=`od -An -t u1 $secure_boot_file`
+ setup_mode=`od -An -t u1 $setup_mode_file`
+
+ if [ $secureboot_mode -eq 1 ] && [ $setup_mode -eq 0 ]; then
+ log_info "secure boot mode enabled"
+ return 1;
+ fi
+ log_info "secure boot mode not enabled"
+ return 0;
+}